package src;

import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Date;
import java.util.Random;

import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.GameCanvas;

import org.kxml2.io.KXmlParser;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;


public class mhCanvas extends GameCanvas implements Runnable {

		private Image imgPointer;
		private Image imgRefresh;
		private Image imgExit;
		private Image imgLogo;
		private int iScreenWidth = getWidth();
		private int iScreenHeight = getHeight();
		private int iPointer_X = iScreenWidth/2;
		private int iPointer_Y = iScreenHeight/2;
		private int iPointerWidth = 10;
		private int iPointerHeight = 10;
		private int iPointerSpeed = 10;
		
		
		private boolean bGo = true;
		
		private String [][] arReadings = new String [20][3];
		private int [][] arLocations = new int [20][4];
		private int iCurrDevice = 0;
		
		private String sURL = "http://itp.nyu.edu/~am2678/NetObj/mh.php";
		private String sQuery = "";
		
		/* FORMATTING VARIABLES */
		private int bgColor = 0xF9F9E3;
		private int fontColor = 0x000000;
		private int offColor = 0x8B8B8B;
		private int onColor = 0x363434;
		private int whiteColor = 0xFFFFFF;
		private int drawColor = 0x3490EF;
		private Font textFont = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
		private Font textBold = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_BOLD, Font.SIZE_SMALL);
		private int iName_X = 10;
		private int iElement1_X = iScreenWidth/2;
		private int iElement2_X = iElement1_X + 110;
		private int iAnalogBarWidth = iScreenWidth/2 - 40;
		private int iAnalogBarHeight = 20;
		
		private mobileHomeMIDlet mh;
		
		private int iMode = 0;
		
		
		public mhCanvas(mobileHomeMIDlet mhIn) {
		  super(true);
		  mh = mhIn;
		}
		
		public void mhExit() {
			System.out.println("Exiting!");
			mh.destroyApp(true);
		}
		
		public void start() {
						
			try {
				imgPointer = Image.createImage("/images/pointer.gif");
				imgRefresh = Image.createImage("/images/btnRefresh.gif");
				imgExit = Image.createImage("/images/btnExit.gif");
				imgLogo = Image.createImage("/images/mobileHOME.gif");
			} catch(IOException ioex) { System.err.println(ioex); }
			  
			Thread runner = new Thread(this);
			runner.start();
		}
		
		public void run() {
					
			//Get initial data
			vResetArray();
			vRefresh();
			
			while(true) { // infinite loop
				
		  		if (bGo) {
		  			// check user's input
		  			checkUserInput();
		  		} //end if Go

	  			// update screen
		  		if (iMode == 1) {
		  			updateAppScreen(getGraphics());
		  		} else {
		  			//splash screen
		  			vSplashScreen(getGraphics());
		  		}
		  		
		  		// sleep, this controls how fast refresh is done
		  		try {
		  			Thread.currentThread().sleep(30);
				} catch(Exception e) {}

			} //end infinite loop
		} //end run function
		
		private void vSplashScreen(Graphics g) {
			g.setColor(bgColor);
			g.fillRect(0,0,getWidth(), getHeight());
			g.drawImage(imgLogo, (iScreenWidth/2) - (imgLogo.getWidth()/2), (iScreenHeight/2) - imgLogo.getHeight(), Graphics.TOP | Graphics.LEFT);
			g.setColor(fontColor);
			g.setFont(textFont);
			g.drawString("A. Maskin & K. Bauer & C. Mangat", iName_X, (iScreenHeight/2) + 20 ,Graphics.TOP | Graphics.LEFT);
			g.setFont(textBold);
			g.drawString("Press Select To Continue", iName_X, (iScreenHeight/2) + 50 ,Graphics.TOP | Graphics.LEFT);
			flushGraphics();
		}

		private void checkUserInput() {
			boolean bLeftOK = true;
			boolean bRightOK = true;
			boolean bUpOK = true;
			boolean bDownOK = true;
			
			// get the state of keys
			int keyState = getKeyStates();
			
			//Check Bounds
			if (iPointer_X  < iPointerWidth) { bLeftOK = false; }
			if (iPointer_X  > (iScreenWidth - iPointerWidth)) { bRightOK = false; }
			if (iPointer_Y  < iPointerHeight) { bUpOK = false; }
			if (iPointer_Y  > (iScreenHeight - iPointerHeight)) { bDownOK = false; }
			
			//Mover pointer where applicable
			if((keyState & LEFT_PRESSED) != 0 & bLeftOK) { 
				iPointer_X = iPointer_X - iPointerSpeed;
			}
			if((keyState & RIGHT_PRESSED) != 0 & bRightOK) { 
				iPointer_X = iPointer_X + iPointerSpeed;
			}
			if((keyState & UP_PRESSED) != 0 & bUpOK) { 
				iPointer_Y = iPointer_Y - iPointerSpeed;
			}
			if((keyState & DOWN_PRESSED) != 0 & bDownOK) { 
				iPointer_Y = iPointer_Y + iPointerSpeed;
			}
			
			//Detect Click
			if((keyState & FIRE_PRESSED) != 0) { 
				vDetectClick();
			}
		  
		} //end check user input
		
		private void updateAppScreen(Graphics g) {
			
			//draws background
			g.setColor(bgColor);
			g.fillRect(0,0,getWidth(), getHeight());
			
			for (int i=0; i < iCurrDevice; i++) {
				//Load labels and Refresh Button
				if (arReadings[i][0].equals("999")) {
					// -- REFRESH & EXIT BUTTONS
					g.drawImage(imgExit, iName_X, arLocations[i][0], Graphics.TOP | Graphics.LEFT);
					g.drawImage(imgRefresh, iScreenWidth - iName_X - 85, arLocations[i][0], Graphics.TOP | Graphics.LEFT);
				} else {
					// -- ALL NON-REFRESH BUTTON ELEMENTS
					g.setColor(fontColor);
					g.setFont(textBold);
					g.drawString(arReadings[i][1], iName_X , arLocations[i][0] ,Graphics.TOP | Graphics.LEFT);
					
					// determine item type
					if (arReadings[i][2].equals("1") || arReadings[i][2].equals("0")) {
						// DIGITAL SWITCH
						g.setColor(onColor);
						g.setFont(textFont);
						g.drawString("On", iElement1_X - 40, arLocations[i][0] ,Graphics.TOP | Graphics.LEFT);
						g.setColor(offColor);
						g.drawString("Off", iElement2_X - 40, arLocations[i][0] ,Graphics.TOP | Graphics.LEFT);
						if (arReadings[i][2].equals("1")) {
							g.setColor(fontColor);
							g.drawRoundRect(iElement1_X, arLocations[i][0], 20, 20, 20, 20);
							g.setColor(whiteColor);
							g.fillRoundRect(iElement1_X + 1, arLocations[i][0] + 1, 19, 19, 19, 19);
							g.setColor(drawColor);
							g.fillRoundRect(iElement1_X + 3, arLocations[i][0] + 3, 15, 15, 15, 15);
							g.setColor(fontColor);
							g.drawRoundRect(iElement2_X, arLocations[i][0], 20, 20, 20, 20);
							g.setColor(whiteColor);
							g.fillRoundRect(iElement2_X + 1, arLocations[i][0] + 1, 19, 19, 19, 19);
						} else {
							g.setColor(fontColor);
							g.drawRoundRect(iElement1_X, arLocations[i][0], 20, 20, 20, 20);
							g.setColor(whiteColor);
							g.fillRoundRect(iElement1_X + 1, arLocations[i][0] + 1, 19, 19, 19, 19);
							g.setColor(fontColor);
							g.drawRoundRect(iElement2_X, arLocations[i][0], 20, 20, 20, 20);
							g.setColor(whiteColor);
							g.fillRoundRect(iElement2_X + 1, arLocations[i][0] + 1, 19, 19, 19, 19);
							g.setColor(drawColor);
							g.fillRoundRect(iElement2_X + 3, arLocations[i][0] + 3, 15, 15, 15, 15);
						} //end if - determines whether on or off is checked
					} else {
						// ANALOG VALUE
						g.setColor(fontColor);
						g.drawRect(iElement1_X, arLocations[i][0], iAnalogBarWidth, iAnalogBarHeight);
						g.setColor(whiteColor);
						g.fillRect(iElement1_X + 1, arLocations[i][0] + 1, iAnalogBarWidth - 3, iAnalogBarHeight -1);
						g.setColor(drawColor);
						g.fillRect(iElement1_X + 1, arLocations[i][0] + 1, (((Integer.parseInt(arReadings[i][2]) + iPointerWidth/2 ) * iAnalogBarWidth)/255) - 3, iAnalogBarHeight -1);
					}
					
				} //end if refresh button
			} //end loop through painting elements
			
			//draw pointer
			g.drawImage(imgPointer, iPointer_X, iPointer_Y, Graphics.TOP | Graphics.LEFT);
	
			// this call paints off screen buffer to screen
			flushGraphics();

		} //end update game screen
		
		public void vDetectClick() {
			iMode = 1;
			// Loop through elements to see what has happened
			for (int i=0; i < iCurrDevice; i++) {
				//Load labels and Refresh Button
				if (arReadings[i][0].equals("999")) {
					if (iPointer_X > (iScreenWidth - iName_X - 85) && iPointer_X < (iScreenWidth - iName_X) &&
						iPointer_Y < (arLocations[i][0]+ imgRefresh.getHeight()) && iPointer_Y > arLocations[i][0]) {
						vRefresh();
					}
					if (iPointer_X > iName_X && iPointer_X < (imgExit.getWidth() + iName_X) &&
						iPointer_Y < (arLocations[i][0]+ imgExit.getHeight()) && iPointer_Y > arLocations[i][0]) {
						mhExit();
					}
				} else {
					//test for digital device Vs. Analog
					if (arReadings[i][2].equals("1") || arReadings[i][2].equals("0")) {
						// DIGITAL SWITCH - ON
						if (iPointer_X >= iElement1_X && iPointer_X <= (20 + iElement1_X) &&
							iPointer_Y <= (arLocations[i][0]+ 20) && iPointer_Y >= arLocations[i][0]) {
							sQuery = "?device=" + arReadings[i][0] + "&setting=1";
							vRefresh();
						}
						// DIGITAL SWITCH - OFF
						if (iPointer_X >= iElement2_X && iPointer_X <= (20 + iElement2_X) &&
							iPointer_Y <= (arLocations[i][0]+ 20) && iPointer_Y >= arLocations[i][0]) {
							sQuery = "?device=" + arReadings[i][0] + "&setting=0";
							vRefresh();
						}
					} else {
						// ANALOG
						if (iPointer_X >= iElement1_X && iPointer_X <= (iAnalogBarWidth + iElement1_X) &&
							iPointer_Y <= (arLocations[i][0]+ iAnalogBarHeight) && iPointer_Y >= arLocations[i][0]) {
							sQuery = "?device=" + arReadings[i][0] + "&setting=" + (255*(iPointer_X - iElement1_X))/iAnalogBarWidth;
							vRefresh();
						}
					}
					
				}
			} //end loop through elements
		
		} //end vDetectClick
		
		public void vRefresh() {
			
			//Clear variables
			iCurrDevice = 0;
			vResetArray();
			
			//Go out to net and get readings
			try {
				HttpConnection httpConnection = (HttpConnection) Connector.open(sURL + sQuery);
				sQuery = "";
				
				KXmlParser parser = new KXmlParser();

				System.out.println("Grabbing XML and parsing");
				parser.setInput(new InputStreamReader(httpConnection.openInputStream()));
				
				System.out.println("looking for first tag");
				parser.nextTag();
				parser.require(XmlPullParser.START_TAG, null, "mobileHOME");			
				
				while (parser.nextTag () != XmlPullParser.END_TAG)
					vReadValue(parser);

				parser.require(XmlPullParser.END_TAG, null, "mobileHOME");
				parser.next();

				parser.require(XmlPullParser.END_DOCUMENT, null, null);
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			// NOTE: Now iCurrDevice contains the quantity of devices
			// Add refresh button
			arReadings[iCurrDevice][0] = "999";
			arReadings[iCurrDevice][1] = "Refresh Button";
			arReadings[iCurrDevice][2] = "-1";
			iCurrDevice = iCurrDevice + 1;
			
			//How far apart can we space the items?
			int iLineSpace = (int) Math.ceil((iScreenHeight - 10)/iCurrDevice); 
			
			//Set Vertical locations for items
			int iCurrY = 10; 	//start listing items here
			for (int i=0; i < iCurrDevice; i++) {
				//Set Y location of item
				arLocations[i][0] = iCurrY;
				iCurrY = iCurrY + iLineSpace;
			} //end loop through readings
			
		} //end vRefresh
		
		void vReadValue(KXmlParser parser)
			throws IOException, XmlPullParserException {
	
			parser.require(XmlPullParser.START_TAG, null, "device");
				
			while (parser.nextTag() != XmlPullParser.END_TAG) {
	
				parser.require(XmlPullParser.START_TAG, null, null);
				
				String name = parser.getName();
				String text = parser.nextText();
	
				System.out.println ("<"+name+">"+text);
	
				if (name.equals("id"))
					arReadings[iCurrDevice][0] = text;
				else if (name.equals("name"))
					arReadings[iCurrDevice][1] = text;
				else if (name.equals("setting"))
					arReadings[iCurrDevice][2] = text;
	
				parser.require(XmlPullParser.END_TAG, null, name);
			}
			parser.require(XmlPullParser.END_TAG, null, "device");
	
			// increment current device
			iCurrDevice = iCurrDevice + 1;
			
		} //end vReadValue
		
		void vResetArray() {
			for(int i=0; i<20; i++) {
				for(int j=0; j<3; j++) {
					arReadings[i][j] = "";
				}
			}
			for(int i=0; i<20; i++) {
				for(int j=0; j<3; j++) {
					arLocations[i][j] = 0;
				}
			}
		} //end vResetArray
		
} //end class def
